Attribute VB_Name = "Module1"
' RW Net 2.06 VB header file
' best thing is to put you rwnet.dll into your system32 directory under Windows or WinNT ...
' otherwise, specify a hardcoded adress for the DLL
' Please relay any disfunction of this header file to
'            info@geovrml.com or eric.maranne@wanadoo.fr
' there's an error conversion routine provided too
' for a french version of error codes contact me
' #############################################################################
' ####### I didn't specify any aliases here, since mine are french ...
' ####### beware of functions names definitions... !!!!!!!!!!!!!!!!!!!
' ############################################################################


Enum rwCoordSys
'Coordinate systems
 XYMiles = 0
 XYKm = 1
 XYInch = 2
 XYft = 3
 XYyd = 4
 XYmm = 5
 XYcm = 6
 XYm = 7
 XYsurveyft = 8
 XYnmi = 9
 LatLong = 10
 XYlink = 30
 XYchain = 31
 XYrod = 32
End Enum

Enum rwUnits
'Units
 UnitKm = 0
 UnitMiles = 1
End Enum




' Read/change properties - all verions
Declare Function GetAlpha Lib "rwnet.dll" () As Double
Declare Function GetCoord Lib "rwnet.dll" () As rwCoordSys 'Integer
Declare Function GetCoord2 Lib "rwnet.dll" () As Integer
Declare Function GetCostDist Lib "rwnet.dll" () As Double
Declare Function GetCostTime Lib "rwnet.dll" () As Double
Declare Function GetExtraDist Lib "rwnet.dll" () As Double
Declare Function GetExtraTime Lib "rwnet.dll" () As Double
Declare Function GetMode Lib "rwnet.dll" () As Integer
Declare Function GetTurnMode Lib "rwnet.dll" () As Integer
Declare Function GetUnit Lib "rwnet.dll" () As rwUnits 'Integer
Declare Function GetUTurnAllowed Lib "rwnet.dll" () As Integer
Declare Function GetVersion Lib "rwnet.dll" () As Integer
Declare Sub SetAlpha Lib "rwnet.dll" (ByVal alpha As Double)
Declare Sub SetCoord Lib "rwnet.dll" (ByVal coord As rwCoordSys) 'Integer)
Declare Sub SetCoord2 Lib "rwnet.dll" (ByVal coord2 As Integer)
Declare Sub SetCostDist Lib "rwnet.dll" (ByVal costdist As Double)
Declare Sub SetCostTime Lib "rwnet.dll" (ByVal costtime As Double)
Declare Sub SetDirectory Lib "rwnet.dll" (ByVal dir As String)
Declare Sub SetExtraDist Lib "rwnet.dll" (ByVal extradist As Double)
Declare Sub SetExtraTime Lib "rwnet.dll" (ByVal extratime As Double)
Declare Sub SetMode Lib "rwnet.dll" (ByVal mode As Integer)
Declare Sub SetResultField Lib "rwnet.dll" (ByVal field As String)
Declare Sub SetResultFileLink Lib "rwnet.dll" (ByVal dir As String)
Declare Sub SetResultFileNode Lib "rwnet.dll" (ByVal dir As String)
Declare Sub SetTurnMode Lib "rwnet.dll" (ByVal turnmode As Integer)
Declare Sub SetUnit Lib "rwnet.dll" (ByVal unit As rwUnits) 'Integer)
Declare Sub SetUTurnAllowed Lib "rwnet.dll" (ByVal uturnallowed As Integer)



' Sub/Function - all versions
Declare Function AirDistNode Lib "rwnet.dll" (ByVal node1 As Long, ByVal node2 As Long) As Double
Declare Function AirDistPos Lib "rwnet.dll" (ByVal Xlong1 As Double, ByVal Ylat1 As Double, ByVal Xlong2 As Double, ByVal Ylat2 As Double) As Double
Declare Function AttributeCreate Lib "rwnet.dll" (ByVal filename As String) As Long
Declare Function AttributeRead Lib "rwnet.dll" (ByVal oneway As Integer) As Long
Declare Function BestNode Lib "rwnet.dll" () As Long
Declare Function CheckLink Lib "rwnet.dll" (ByVal link As Long) As Integer
Declare Function CheckNode Lib "rwnet.dll" (ByVal node As Long) As Integer
Declare Function ExtraVarCreate Lib "rwnet.dll" () As Long
Declare Sub ExtraVarDrop Lib "rwnet.dll" ()
Declare Function ExtraVarExist Lib "rwnet.dll" () As Integer
Declare Function FindNode Lib "rwnet.dll" (ByVal XLong As Double, ByVal YLat As Double, node As Long, dist As Double) As Long
Declare Function GetLinkCost Lib "rwnet.dll" (ByVal link As Long) As Double
Declare Function GetLinkExtra Lib "rwnet.dll" (ByVal link As Long) As Double
Declare Function GetNodeCost Lib "rwnet.dll" (ByVal node As Long) As Double
Declare Function GetNodeExtra Lib "rwnet.dll" (ByVal node As Long) As Double
Declare Sub Init Lib "rwnet.dll" (ByVal password As Long)
Declare Function LinkLimit Lib "rwnet.dll" () As Long
Declare Function LinkMax Lib "rwnet.dll" () As Long
Declare Function NodeCoordX Lib "rwnet.dll" (ByVal node As Long) As Double
Declare Function NodeCoordY Lib "rwnet.dll" (ByVal node As Long) As Double
Declare Function NodeCreate Lib "rwnet.dll" () As Long
Declare Function NodeMax Lib "rwnet.dll" () As Long
Declare Function NWCreateMIF Lib "rwnet.dll" (ByVal filename As String, ByVal nodemif As Integer) As Long
Declare Function NWCreateSHP Lib "rwnet.dll" (ByVal filename As String, ByVal nodemif As Integer, ByVal coordsys As String) As Long
Declare Function NWCreateTAB Lib "rwnet.dll" (ByVal filename As String, ByVal nodemif As Integer) As Long
Declare Function NWLoad Lib "rwnet.dll" () As Long
Declare Function NWLoaded Lib "rwnet.dll" () As Integer
Declare Sub NWUnLoad Lib "rwnet.dll" ()
Declare Function ResultFileClear Lib "rwnet.dll" (ByVal link As Integer, ByVal node As Integer) As Long
Declare Function RoundAbout Lib "rwnet.dll" (ByVal link As Long) As Integer
Declare Function Route Lib "rwnet.dll" (ByVal node1 As Long, ByVal node2 As Long) As Double
Declare Function RouteFind Lib "rwnet.dll" (ByVal node As Long) As Long
Declare Function RouteGetLink Lib "rwnet.dll" (ByVal index As Long) As Long
Declare Function RouteGetNode Lib "rwnet.dll" (ByVal index As Long) As Long
Declare Function RouteReady Lib "rwnet.dll" () As Integer
Declare Function RouteSave Lib "rwnet.dll" (ByVal link As Integer, ByVal node As Integer) As Long
Declare Sub SetSpeed Lib "rwnet.dll" (ByVal roadclass As Integer, ByVal speed As Double)
Declare Function Valency Lib "rwnet.dll" (ByVal node As Long) As Long


' Sub/Function - standard and pro version
Declare Function AttributeSet Lib "rwnet.dll" (ByVal link As Long, ByVal newattrib As Integer) As Long
Declare Function CloseLink Lib "rwnet.dll" (ByVal link As Long, ByVal code As Integer) As Long
Declare Function Direction1 Lib "rwnet.dll" (ByVal node1 As Long, ByVal node2 As Long, ByVal node3 As Long) As Long
Declare Function Direction2 Lib "rwnet.dll" (ByVal link1 As Long, ByVal node2 As Long, ByVal link2 As Long) As Long
Declare Function FindNodeFast Lib "rwnet.dll" (ByVal XLong As Double, ByVal YLat As Double, node As Long, dist As Double) As Long
Declare function GetLinkSpeed Lib "rwnet.dll" (byval link as Long) as double
Declare function GetLinkTime Lib "rwnet.dll" (byval link as Long) as double
Declare Function IsoCost Lib "rwnet.dll" (ByVal node As Long, ByVal MaxCost As Double) As Long
Declare Function IsoCostSave Lib "rwnet.dll" (ByVal link As Integer, ByVal node As Integer, ByVal complete As Integer) As Long
Declare Function IsoCostMulti Lib "rwnet.dll" (ByVal Nodenum As Long, ByVal MaxCost As Double) As Long
Declare Function IsoGrid Lib "rwnet.dll" (ByVal Nodenum As Long, ByVal Xlong1 As Double, ByVal Ylat1 As Double, ByVal Xlong2 As Double, ByVal Ylat2 As Double, ByVal gridV As Long, ByVal gridH As Long, ByVal roundoff As Double) As Long
Declare Function IsoPoly1 Lib "rwnet.dll" (ByVal filename As String, ByVal node As Long, ByVal cost1 As Double, ByVal cost2 As Double, ByVal numpoly As Long, ByVal doughnut As Integer, ByVal convex As Double) As Long
Declare function IsoPoly2 Lib "rwnet.dll" (byval filename as string, byval nodenum as Long) as Long
Declare function IsoPoly3 Lib "rwnet.dll" (byval filename as string, byval maxcost as double, byval nodenum as Long, byval min_valency as Long, byval Xlong1 as double, byval Ylat1 as double, byval Xlong2 as double, byval Ylat2 as double) as Long
Declare Function NearestNode Lib "rwnet.dll" (ByVal node As Long, ByVal size As Long) As Long
Declare Function NodeIndexCreate Lib "rwnet.dll" () As Long
Declare Sub NodeIndexDrop Lib "rwnet.dll" ()
Declare Function NodeIndexExist Lib "rwnet.dll" () As Integer
Declare Function NodeListGet Lib "rwnet.dll" (ByVal index As Long) As Long
Declare Function NodeListLimit Lib "rwnet.dll" () As Long
Declare Function NodeListSet Lib "rwnet.dll" (ByVal index As Long, ByVal node As Long) As Long
Declare Function OptimumAlpha Lib "rwnet.dll" () As Double
Declare Sub ResultDrop Lib "rwnet.dll" ()
Declare Function ResultGetLink Lib "rwnet.dll" (ByVal link As Long) As Double
Declare Function ResultGetNode Lib "rwnet.dll" (ByVal node As Long) As Double
Declare Function ResultSaveLink Lib "rwnet.dll" () As Long
Declare Function ResultSaveNode Lib "rwnet.dll" () As Long
Declare function RouteVia Lib "rwnet.dll" (byval node1 as Long, byval node2 as Long, byval nodenum as Long) as Long
Declare function SetLinkSpeed Lib "rwnet.dll" (byval link as Long, byval speed as double) as Long
Declare function SetLinkSpeedDefault Lib "rwnet.dll" (byval link as Long) as Long
Declare Function SetLinkTime Lib "rwnet.dll" (ByVal link As Long, ByVal time As Double) As Long
Declare Sub ShowProgress Lib "rwnet.dll" (ByVal yesno As Integer, ByVal exhandle As Long)
Declare Sub StepsAdd Lib "rwnet.dll" (byval step as double)
Declare Sub StepsClear Lib "rwnet.dll"
Declare Function TSP Lib "rwnet.dll" (ByVal size As Long, ByVal roundtrip As Integer) As Double
Declare Function TurnRestriction Lib "rwnet.dll" (ByVal link1 As Long, ByVal link2 As Long, ByVal cost As Double) As Long
Declare Function TurnStandard Lib "rwnet.dll" (ByVal node As Long) As Long


' Sub/Function - pro version
Declare Function Assignment Lib "rwnet.dll" (byval filename as string, byval Atype as integer, byVal Grouped as integer) as Long
Declare Function CulDeSac Lib "rwnet.dll" (ByVal ctype As Integer) As Long
Declare Function FindCloseNodes Lib "rwnet.dll" (ByVal snap As Double) As Long
Declare Function FindRoundAbout Lib "rwnet.dll" (ByVal maxlink As Long, ByVal maxradius As Double) As Long
Declare Function Join Lib "rwnet.dll" (ByVal maxlength As Double, ByVal filename As String) As Long
Declare Function ParallelLinks Lib "rwnet.dll" () As Long
Declare Function SubNet Lib "rwnet.dll" () As Long
Declare Function UnUsedLinks Lib "rwnet.dll" () As Long


Function rwErrorInfo(ByVal rwErrNum As Variant) As String
Select Case rwErrNum
    Case -10
             rwErrorInfo = "Network not loaded"
    Case -11
             rwErrorInfo = "RW Net has expired"
    Case -12
             rwErrorInfo = "Network too big for license"
    Case -14
             rwErrorInfo = "Too many links at one node (no more than 1900)"
    Case -15
             rwErrorInfo = "Wrong version code in network file"
    Case -16
             rwErrorInfo = "Not in turnmode"
    Case -20
             rwErrorInfo = "Field name not found in output file"
    Case -21
             rwErrorInfo = "Field isn't of type number/decimal 11.3"
    Case -30
             rwErrorInfo = "Number out of bounds"
    Case -31
             rwErrorInfo = "Couldn't load network : wrong path, file not found etc"
    Case -32
             rwErrorInfo = "Output file couldn't be found, opened etc."
    Case -33
             rwErrorInfo = "Node2 not found"
    Case -34
             rwErrorInfo = "No node index created"
    Case -35
             rwErrorInfo = "Route not ready"
    Case -36
             rwErrorInfo = "Route index out of bounds"
    Case -37
             rwErrorInfo = "No results calculated"
    Case -38
             rwErrorInfo = "TSP : One or more nodes in subnet"
    Case -39
             rwErrorInfo = "ExtraVar hasn't been created"
    Case -40
             rwErrorInfo = "General error"
    Case -41
             rwErrorInfo = "Out of memory"
    Case -42
             rwErrorInfo = "Internal error"
    Case -50
             rwErrorInfo = "Stopped by user"
    Case -54
             rwErrorInfo = "Not available in Turnmode"
    Case Else
             rwErrorInfo = "Unknown error"
End Select
End Function
