unit about;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, StdCtrls,
     Buttons, ExtCtrls, OleCtrls, ShellApi, sysutils;

type
  TAboutBox = class(TForm)
    OKButton: TBitBtn;
    ProductName: TLabel;
    Comments: TLabel;
    Label1: TLabel;
    procedure ProductNameClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  AboutBox: TAboutBox;

implementation

{$R *.DFM}

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;

procedure TAboutBox.ProductNameClick(Sender: TObject);
begin
  ExecuteFile('http://www.routeware.dk/','','',1);
  close; 
end;

end.


